package com.ozs.web.controller.websocket;

import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ozs.common.core.controller.BaseController;
import com.ozs.common.core.domain.entity.SysUser;
import com.ozs.common.utils.AppendUtils;
import com.ozs.common.utils.StringUtils;
import com.ozs.service.entity.BaseCameraManagement;
import com.ozs.service.entity.MsgAlarm;
import com.ozs.service.entity.MsgAppPush;
import com.ozs.service.entity.MsgWebPush;
import com.ozs.service.entity.vo.MsgAlarmResp;
import com.ozs.service.service.*;
import com.ozs.system.service.ISysUserService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Author : sunhh
 * @create 2023/3/13 22:08
 */
@Slf4j
@Controller
@RequestMapping("/sdk")
public class WebSocketConteoller extends BaseController {

    @Autowired
    private WebSocketServer webSocketServer;
    @Autowired
    private BaseUserService baseUserService;
    @Autowired
    private ISysUserService userService;
    @Resource
    private BaseRailwayManagementService baseRailwayManagementService;
    @Autowired
    private BaseCameraManagementService baseCameraManagementService;
    @Autowired
    private UserRegistrationidService userRegistrationidService;
    @Autowired
    private MsgWebPushService msgWebPushService;
    @Autowired
    private MsgAppPushService msgAppPushService;

    @ResponseBody
    @PostMapping("/publish")
    public Map publish(@RequestBody MsgAlarm msgAlarm) {
        log.info("消息推送:" + msgAlarm.toString());
        LambdaQueryWrapper<BaseCameraManagement> wrapper = new LambdaQueryWrapper<BaseCameraManagement>();
        if (!ObjectUtils.isEmpty(msgAlarm.getCameraCode())) {
            wrapper.eq(BaseCameraManagement::getCameraCode, msgAlarm.getCameraCode());
        }
        BaseCameraManagement baseCameraManagement = baseCameraManagementService.getOne(wrapper);
        log.info("baseCameraManagement-----" + baseCameraManagement);
        // 获取推送人ID列表
        log.info("publish-----" + baseCameraManagement.getCreateBy() + "-------------" + baseCameraManagement.getDeptId());
        Set<String> set = baseUserService.getUserIdList(baseCameraManagement.getCreateBy(), baseCameraManagement.getDeptId());
        log.info("set-----" + set);
        String[] list = set.toArray(new String[set.size()]);
        List<String> userIdList = new ArrayList<>(set);
        MsgAlarmResp msgAlarmResp = new MsgAlarmResp();
        String begin = AppendUtils.stringAppend(baseCameraManagement.getBeginMile());
        String end = AppendUtils.stringAppend(baseCameraManagement.getEndMile());
        String endMile = begin + "-" + end;
        msgAlarmResp.setBeginMile(endMile);
        msgAlarmResp.setAlarmType(msgAlarm.getAlarmType());
        String mile = AppendUtils.stringAppend(baseCameraManagement.getInstallMile());
        msgAlarmResp.setAlarmMile(mile);
        String cameraCode = baseCameraManagement.getCameraCode();
        String cameraName = baseRailwayManagementService.getCameraNameByCameraCode(cameraCode);
        msgAlarmResp.setRailwayName(cameraName != null ? cameraName : "");
        msgAlarmResp.setLineDirStr(baseCameraManagement.getLineDir() == 1 ? "上行" : "下行");
        msgAlarmResp.setAlarmTime(msgAlarm.getAlarmTime() != null ? msgAlarm.getAlarmTime() : new Date());
        // 图片
        if (!StringUtils.isEmpty(msgAlarm.getImageUrl())) {
            String[] split = msgAlarm.getImageUrl().split(";");
            ArrayList<String> objects = new ArrayList<>(Arrays.asList(split));
            log.info("publish--------" + objects);
            msgAlarmResp.setImageUrls(objects);
        }
        if (!StringUtils.isEmpty(msgAlarm.getId())) {
            msgAlarmResp.setId(msgAlarm.getId());
        }
        String userIdLogin = "admin编码";
        SysUser user = userService.selectUserById(1L);
        if (!ObjectUtils.isEmpty(user)) {
            userIdLogin = user.getUserId();
        }
        String alarmId = msgAlarm.getAlarmId();
        for (String userid : list) {
            String pushId = UUID.randomUUID().toString();
            msgAlarmResp.setPushId(pushId);
            String content = objStr(msgAlarmResp);
            log.info("WEBcontent-----" + content);
            log.info("WEBuserid-----" + userid);
            // 推送消息reqMsgAlarmVo
            webSocketServer.sendOneMessage(userid, content);

            // 存入数据
            MsgWebPush msgWebPush = new MsgWebPush();
            // 状态：1未读；2已读
            msgWebPush.setStatus(1);
            msgWebPush.setPushId(pushId);
            msgWebPush.setAlarmId(alarmId);
            msgWebPush.setReceiveBy(userid);
            msgWebPush.setCreateBy(userIdLogin);
            msgWebPush.setCreateTime(new Date());
            msgWebPush.setUpdateBy(userIdLogin);
            msgWebPush.setUpdateTime(new Date());
            msgWebPushService.save(msgWebPush);
        }
//        String content = objStr(msgAlarmResp);
//        // 推送消息reqMsgAlarmVo
//        webSocketServer.sendMoreMessage(list, content);
        // app 消息推送
        List<String> alias = new ArrayList<>();
        if (!StringUtils.isEmpty(userIdList) || userIdList.size() > 0) {
            alias = userRegistrationidService.selectRegistrationID(userIdList);
        }
        // List<String> alias = new ArrayList<String>();
        // alias.add("sunhh");
        // list去重
        List<String> listString = distinct(alias);
        if (!StringUtils.isEmpty(listString) || listString.size() > 0) {
            for (String userid : listString) {
                String pushId = UUID.randomUUID().toString();
                msgAlarmResp.setPushId(UUID.randomUUID().toString());
                String content = objStr(msgAlarmResp);
                Date alarmTime = msgAlarm.getAlarmTime();
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                String formatDate = sdf.format(alarmTime != null ? alarmTime : new Date());
                log.info("APPcontent-----" + content);
                log.info("APPuserid-----" + userid);
                List<String> userList = new ArrayList<>();
                userList.add(userid);
                JPushUtil.sendToRegistrationId(
                        userList,
                        "报警通知！", cameraName != null ? cameraName : "",
                        // content,
                        formatDate + "     " + (msgAlarmResp.getAlarmType() == 1 ? "泥石流" : msgAlarmResp.getAlarmType()) + "     " + (baseCameraManagement.getLineDir() == 1 ? "上行" : "下行") + "     " + mile + "     " + endMile,
                        content);

                // 存入数据
                MsgAppPush msgAppPush = new MsgAppPush();
                // 状态：1未读；2已读
                msgAppPush.setStatus(1);
                msgAppPush.setPushId(pushId);
                msgAppPush.setAlarmId(alarmId);
                msgAppPush.setReceiveBy(userid);
                msgAppPush.setCreateBy(userIdLogin);
                msgAppPush.setCreateTime(new Date());
                msgAppPush.setUpdateBy(userIdLogin);
                msgAppPush.setUpdateTime(new Date());
                msgAppPushService.save(msgAppPush);
            }
//            Date alarmTime = msgAlarm.getAlarmTime();
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//            String formatDate = sdf.format(alarmTime != null ? alarmTime : new Date());
//            JPushUtil.sendToRegistrationId(
//                    listString,
//                    "报警通知！", cameraName != null ? cameraName : "",
//                    // content,
//                    formatDate + "     " + (msgAlarmResp.getAlarmType() == 1 ? "泥石流" : msgAlarmResp.getAlarmType()) + "     " + (baseCameraManagement.getLineDir() == 1 ? "上行" : "下行") + "     " + mile + "     " + endMile,
//                    content);
        }
//        // 存入数据
//        if (!StringUtils.isEmpty(msgAlarm.getAlarmId()) || !StringUtils.isEmpty(userIdList)) {
//            String userIdLogin = "admin编码";
//            SysUser user = userService.selectUserById(1L);
//            if (!ObjectUtils.isEmpty(user)) {
//                userIdLogin = user.getUserId();
//            }
//            String alarmId = msgAlarm.getAlarmId();
//            for (String userId : userIdList) {
//                MsgWebPush msgWebPush = new MsgWebPush();
//                // 状态：1未读；2已读
//                msgWebPush.setStatus(1);
//                msgWebPush.setAlarmId(alarmId);
//                msgWebPush.setReceiveBy(userId);
//                msgWebPush.setCreateBy(userIdLogin);
//                msgWebPush.setCreateTime(new Date());
//                msgWebPush.setUpdateBy(userIdLogin);
//                msgWebPush.setUpdateTime(new Date());
//                msgWebPushService.save(msgWebPush);
//                if (!StringUtils.isEmpty(alias) || alias.size() > 0) {
//                    MsgAppPush msgAppPush = new MsgAppPush();
//                    BeanUtils.copyProperties(msgWebPush, msgAppPush);
//                    msgAppPushService.save(msgAppPush);
//                }
//            }
//        }
        HashMap<String, Object> map = new HashMap<>();
        map.put("code", 200);
        return map;
    }

    /**
     * 去除重复数据
     * 由于Set的无序性，不会保持原来顺序
     *
     * @param list
     */
    public static List<String> distinct(List<String> list) {
        final boolean sta = null != list && list.size() > 0;
        List doubleList = new ArrayList();
        if (sta) {
            Set set = new HashSet();
            set.addAll(list);
            doubleList.addAll(set);
        }
        return doubleList;
    }

    private String objStr(MsgAlarmResp msgAlarmResp) {
        JSONObject obj = new JSONObject();
        obj.put("data", msgAlarmResp); //data
        obj.put("code", 110); //code
        log.info("【websocket消息】 单点消息:" + obj.toJSONString());
        return obj.toJSONString();
    }
}
